import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Dimension;

import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;

import javax.swing.filechooser.FileNameExtensionFilter;

public class arbeidsmediumFane extends JPanel {
	JLabel labelArbeidsmediumNavn;
	JTable table;
	JScrollPane scrollPane;
	arbeidsmedium valgtarbeidsmedium;
	JTextField textMolarMasse;
	JTextField textNavn;

	public arbeidsmediumFane() {
		setLayout(new BorderLayout(5, 5));
		valgtarbeidsmedium = new arbeidsmedium(); // Lager tomt arbeidsmedium.

		// Navn p arbeidsmedium (filnavn)
		labelArbeidsmediumNavn = new JLabel("Arbeidsmedium");
		add(labelArbeidsmediumNavn, BorderLayout.NORTH);

		// Lager tabell med scrollbars
		table = new JTable(new Object[18][12],
				valgtarbeidsmedium.arbeidsmediumKolonneOverskrifter);
		scrollPane = new JScrollPane(table,
				JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
				JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		table.setFillsViewportHeight(true);
		table.setDragEnabled(false);
		table.setPreferredScrollableViewportSize(new Dimension(500, 200));
		table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		table.setDragEnabled(false);
		add(scrollPane, BorderLayout.CENTER);

		// Lager knapperad med pne og lukke knapp
		JPanel knapperad = new JPanel(new GridLayout(3, 2, 80, 2));

		JLabel labelNavn = new JLabel("Arbeidsmediumnavn:");
		knapperad.add(labelNavn);
		textNavn = new JTextField("navn");
		knapperad.add(textNavn);

		JLabel labelIndreRadius = new JLabel("Molar masse M:");
		knapperad.add(labelIndreRadius);
		textMolarMasse = new JTextField("0.0");
		knapperad.add(textMolarMasse);

		Button opneKnapp = new Button("pne arbeidsmedium");
		Button lagreKnapp = new Button("Lagre arbeidsmedium");

		knapperad.add(opneKnapp);
		knapperad.add(lagreKnapp);

		add(knapperad, BorderLayout.SOUTH);

		// Hndterer events (kanpper blir trykt p)
		opneKnapp.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				opneArbeidsmediumDialog();
			}
		});

		lagreKnapp.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				lagreArbeidsmediumDialog();
			}
		});

	}

	public void opneArbeidsmediumDialog() {
		JFileChooser fildialog = new JFileChooser();
		fildialog.setFileFilter(new FileNameExtensionFilter(
				"Arbeidsmedium (.arm)", "arm"));
		int returnVal = fildialog.showOpenDialog(this);

		if (returnVal == JFileChooser.APPROVE_OPTION) {
			File file = fildialog.getSelectedFile();
			FileInputStream fis = null;
			ObjectInputStream in = null;
			try {
				fis = new FileInputStream(file);
				in = new ObjectInputStream(fis);
				valgtarbeidsmedium = (arbeidsmedium) in.readObject();
				in.close();

				for (int y = 0; y < valgtarbeidsmedium.arbeidsmediumData.length; y++) {
					for (int x = 0; x < 12; x++) {
						table.setValueAt(
								valgtarbeidsmedium.arbeidsmediumData[y][x], y,
								x);
					}
				}
				String verdi = Double.toString(valgtarbeidsmedium.molarMasse);
				if (verdi != "NaN") {
					textMolarMasse.setText(verdi);
				}

				verdi = valgtarbeidsmedium.arbeidsmediumNavn;
				if (verdi != "NaN") {
					textNavn.setText(verdi);
				}
				JOptionPane.showMessageDialog(null, "Arbeidsmedium importert");
			} catch (IOException ex) {
				JOptionPane.showMessageDialog(null,
						"Feil ved import av arbeidsmedium.", "Feil",
						JOptionPane.ERROR_MESSAGE);
				ex.printStackTrace();
			} catch (ClassNotFoundException ex) {
				JOptionPane.showMessageDialog(null,
						"Feil ved import av arbeidsmedium.", "Feil",
						JOptionPane.ERROR_MESSAGE);
				ex.printStackTrace();

			}

		}

	}

	public void lagreArbeidsmediumDialog() {

		try {

			valgtarbeidsmedium.molarMasse = Double.parseDouble(textMolarMasse
					.getText());
			valgtarbeidsmedium.arbeidsmediumNavn = textNavn.getText();
		} catch (NumberFormatException e) {
			System.out
					.println("Feil ved konvertering fra String til Double (veke)"
							+ e);
		}

		JFileChooser fildialog = new JFileChooser();
		fildialog.setFileFilter(new FileNameExtensionFilter(
				"Arbeidsmedium (.arm)", "arm"));
		int returnVal = fildialog.showSaveDialog(this);

		if (returnVal == JFileChooser.APPROVE_OPTION) {
			File file = fildialog.getSelectedFile();
			FileOutputStream fos = null;
			ObjectOutputStream out = null;
			try {
				fos = new FileOutputStream(file);
				out = new ObjectOutputStream(fos);
				out.writeObject(valgtarbeidsmedium);
				out.close();
			} catch (IOException ex) {
				ex.printStackTrace();
			}
		}
	}

	public Insets getInsets() {
		// Creates and initializes a new Insets object with the specified
		// top, left, bottom, and right insets.
		return new Insets(10, 10, 10, 10);
	}
}
