
public class likningsett {

//Gir teoretisk maks kappilrt trykk
public double youngLaplace(double overflatespenning,double poreradius,double kontaktvinkel)
	{
	if (!Double.isNaN(overflatespenning) & !Double.isNaN(poreradius) & !Double.isNaN(kontaktvinkel)) 
		{
		return (2*overflatespenning*Math.cos(kontaktvinkel))/poreradius;
		}
	
	System.out.println("Young-Laplace ikke kalkulert");
	return 0.0;	
	}

//(*@\label{re_radiell}@*)
public double Re_radiell(double z, double u_v,double Le, double La,double Lk,double Qe,double hfg) //radielt reynoldstall
	{
	return (1/(2*Math.PI*u_v))*m_damp_derivert(z,Le,La,Lk,Qe,hfg);
	}

public double m_damp_derivert(double z, double Le, double La, double Lk,double Qe,double hfg) //egentlig  massestrm damp generert i fordamper eller kondensert i kondensator
{
if (z <= Le)
	{
	return (1/Le)*(Qe/hfg);
	}
else if (z > Le && z<= (Le +La))
	{
	return 0.0;
	}
else if (z > (Le+La) && z<= (Le +La+Lk))
	{
	
	return (-1/Lk)*(Qe/hfg);
	}
else {
	System.out.println("Feil: utenfor omrde i funksjon m_damp");
	return 0.0;}

}

//(*@\label{m_damp}@*)
public double m_damp(double z, double Le, double La, double Lk,double Qe,double hfg) //egentlig  massestrm damp generert i fordamper eller kondensert i kondensator
	{
	if (z <= Le)
		{
		return (z/Le)*(Qe/hfg);
		}
	else if (z > Le && z<= (Le +La))
		{
		return (Qe/hfg);
		}
	else if (z > (Le+La) && z<= (Le +La+Lk))
		{
		
		return ((Le+La+Lk-z)/Lk)*(Qe/hfg);
		}
	else {
		System.out.println("Feil: utenfor omrde i funksjon m_damp");
		return 0.0;}
	
	}


public double m_veske(double z, double Le, double La, double Lk,double Qe,double hfg){
if (z <= Le)//Fordamper
	{
	return ((z/Le))*(Qe/hfg);
	}
else if (z > Le && z<= (Le +La))
	{
	return (Qe/hfg);
	}
else if (z > (Le+La) && z<= (Le +La+Lk))
	{
	return (((Le+La+Lk-z)/Lk))*(Qe/hfg);
	
	}
else {
	System.out.println("Feil: utenfor omrde i funksjon m_veske z=" + Double.toString(z));
	return 0.0;}

}


//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= LIKNINGER FOR DAMPTRYKK I HEAT PIPE-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//(*@\label{Pv}@*)
public double Pv_by_simplified_closed_form_approximation_euler(double p1,double stepSize,double z, double u_v,double Le, double La,double Lk,double Qe,double hfg,double rho_v,double Rv)
	{
	//System.out.println("Re_radiell " +Re_radiell(z,u_v,Le,La,Lk,Qe,hfg));
	//System.out.println("z: "+z + " u_v: "+u_v + " Le "+Le + " Qe " + Qe + " hfg " + hfg);
	if (Math.abs(Re_radiell(z,u_v,Le,La,Lk,Qe,hfg)) < 1) //egentlig |Re| << 1 (bassert p Faghri likning 3.61)
		{
		
			//System.out.println(" u_v: "+u_v + " Qe " + Qe +"z^2" + Math.pow(z,2) + " PI "+Math.PI + " Rho_v " +rho_v +" Rv^4 " +  Math.pow(Rv, 4) + " hfg " + hfg + " le " + Le);
	
			return p1 + ((-8*u_v*m_damp(z,Le,La,Lk,Qe,hfg))/(Math.PI*rho_v*Math.pow(Rv, 4))*(1+(3/4)*Re_radiell(z,u_v,Le,La,Lk,Qe,hfg)))*stepSize;
			
		}
	else if (Math.abs(Re_radiell(z,u_v,Le,La,Lk,Qe,hfg)) > 1) //|Re| >> 1
		{
		if (z >= 0 && z <= Le)//Fordamper
			{
			return p1 +(((-m_damp(z,Le,La,Lk,Qe,hfg))/(4*rho_v*Math.pow(Rv, 4)))*(Qe/(Le*hfg)))*stepSize;
			}
		else if (z > Le && z <= (Le+La))
			{
			return p1 + 0.0*stepSize; 
			}
		else if (z > (Le+La) && z <= (Le+La+Lk))
			{
			return p1 + (((-(4/Math.pow(Math.PI, 2))*m_damp(z,Le,La,Lk,Qe,hfg))/(4*rho_v*Math.pow(Rv, 4)))*(-Qe/(Lk*hfg)))*stepSize;
			}
		}
	else //Re = 1...what to do
		{
		return 0.0;
		}
	return 0.0;
	}



//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= LIKNINGER FOR VSKETRYKK I VEKE -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
public double Pl(double p1, double stepSize, double z, double u_l, double rho_l, double A_veke, double K, double Le, double La, double Lk,double Qe, double hfg)
	{
	return p1 - ((u_l*m_veske(z,Le,La,Lk,Qe,hfg))/(rho_l*A_veke*K))*stepSize;
	
	}

public double Pkapp_max(double sigma, double reff)
	{
	//return 2*sigma*Math.cos(fluidKontaktVinkel)/reff;
	return 2*sigma/reff;
	}


//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= LIKNINGER FOR BEGRENSNINGER -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

public boolean capilary_limit_reached(double sigma,double reff,double pv[],double pl[],double rho_l,double tilt,double Le,double La,double Lk) //(*@\label{capLimit}@*)
	{
	int wetpoint = getWetpoint(pv, pl, Lk,La,Le);
	
	if (wetpoint >= pv.length-2) La+=Lk; //kompanserer for Wetpoint ved endcap
		if((2*sigma)/reff < Math.abs((pl[0]-pl[wetpoint]) + Math.abs(pv[0]-pv[wetpoint])) + rho_l*9.81*Math.sin(Math.toRadians(tilt))*(La+Le))
			{	
			return true;
			}
		else return false;

	}


//(*@\label{boilingLimit}@*)
public double boilingLimit(double Le,double keff,double Ri,double Rv,double sigma,double T_v, double hfg, double rho_v,double Rmen, double tsat, double kl, double v_v,double v_l, double qr)
	{
	//Denne returnerer i enhet WATT dvs qr m bli gitt i watt
	return (   (2*Math.PI*Le*keff*Tkritisk( sigma, T_v,  hfg,  rho_v, Rmen,  tsat,  kl,  v_v, v_l,  qr)) / (Math.log(Ri/Rv))   );
	}

//(*@\label{Tkritisk}@*)
public double Tkritisk(double sigma,double T_v, double hfg, double rho_v,double Rmen, double tsat, double kl, double v_v,double v_l, double qr)
	{
	return ((2*sigma*T_v)/(1000*hfg*rho_v))*((1/0.0000010)-(1/Rmen)); //OPSOPS T_V er kanskje ikkje rett her!!!
	}





public double rb(double sigma, double tsat, double kl, double v_v,double v_l, double hfg, double qr)
	{
	if (sigma == Double.NaN || tsat == Double.NaN || kl == Double.NaN || v_v == Double.NaN || v_l == Double.NaN || hfg == Double.NaN || qr == Double.NaN)
		{return 0.0000010;} //anbefalt verdi av faghri
	else 
		{
		return Math.sqrt((2*sigma*tsat*kl*(v_v-v_l))/(hfg*qr));
		}
	}


public double speedOfSound(double cp,double R, double Pv,double rho_v)
	{
	return Math.sqrt((cp/(cp-R))*(Pv/rho_v));
	}

public double sonicLimit(double Ri,double hfg, double rho_v,double K, double T_v) //(*@\label{sonicLimit}@*)
	{
	return (Math.PI*Math.pow(Ri, 2))*rho_v*hfg*1000*Math.sqrt(  (K*T_v*8.314)/(2*(K+1)) );
	}

public boolean okToNegclectCompressibleFlow(double z, double Le, double La, double Lk,double Qe,double hfg,double rho_v,double Pv,double cp,double cv,double crossSectionArea)
	{
	double massFlow = m_damp(z,Le,La,Lk, Qe,hfg);
	double w = speedOfFlow(massFlow,rho_v,crossSectionArea);
	double c = speedOfSound(cp,cv,Pv,rho_v);
	if (w/c <= 0.3) return true;
	else return false;
	}
public double speedOfFlow(double massFlow,double rho,double crossSectionArea)
	{
	return massFlow/(rho*crossSectionArea);
	}

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= LIKNINGER FOR FILMKONDENSASJON -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

public double Prandtl(double Cp,double u, double k)
	{
	return (Cp*u)/k;
	}

public double kinematisk_viskositet(double u_l,double rho_l) //ul [pa*sec] og Rho [kg/m^3] returnerer m^2/sec
	{
	
	return u_l/rho_l;
	}



//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= ANDRE RUTINER -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
public int getLowestValuePosition(double[] array) //Finner laveste verdi i denne arrayen og returnerer posisjon (Treig algoritme)
	{
	int position = 0;
	for (int i=0;i < array.length;i++)
		{
		if (array[i] < array[position]) position = i;
		
		}
	return position;
	}

public double aritmetiskMiddelTemperatur(double Tinn,double Tut)
	{
	return (Tinn + Tut)/2;
	}

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= TERMISK GRENESKIKT  -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
public double h_delta(double alpha,double hfg,double Tv, double vfg, double rho_v, double Mv)//(*@\label{h_delta}@*)
	{
	//System.out.println("Her: " + Double.toString(  vfg )                          );
	return ((2*alpha)/(2-alpha)) *(Math.pow(hfg,2)/(Tv*vfg))    *     Math.sqrt((Mv/(2*Math.PI))*8.314*Tv)  *    (1-((rho_v*vfg)/(2*hfg)))  ;	
	
	}

public double keff(int veketype,double kl,double ks,double porositet) //(*@\label{keff}@*)
	{
	if (veketype==veke.SINTREDE_VEKER_AV_METALLPULVER) //sintrede veker av metallpulver
		{
		return (2+kl/ks-2*porositet*(1-kl/ks))/(2+kl/ks-porositet*(1-kl/ks));
		}
	else if (veketype==veke.METALLNETT) //sintrede veker av metallpulver
		{
		return (kl*((kl+ks)-(1-porositet)*(kl-ks)))/ ((kl+ks)+(1-porositet)*(kl-ks));
		}
	
	else return 0.0;
	}

public double R_kondensator(double h_veskeDampGrensesnitt,double h_kondensfilm,double keff,double kvegg,double Rv,double Ri,double Ry,double L)
	{
	double veskeDampGrensesnitt = 1/(h_veskeDampGrensesnitt*2*Math.PI*Rv*L);
	
	//double kondensfilm = 1/(h_kondensfilm*2*Math.PI*Rv*L);
	double kondensfilm = 0.0;
	
	double veke = Math.log(Ri/Rv)/(2*Math.PI*L*keff);
	
	double vegg = Math.log(Ry/Ri)/(2*Math.PI*L*kvegg);
	
	return  veskeDampGrensesnitt+kondensfilm+veke+vegg;
	}

public double R_fordamper(double h_veskeDampGrensesnitt,double keff,double kvegg,double Rv,double Ri,double Ry,double L)
	{
	double veskeDampGrensesnitt = 1/(h_veskeDampGrensesnitt*2*Math.PI*Rv*L);
		
	double veke = Math.log(Ri/Rv)/(2*Math.PI*L*keff);
	
	double vegg = Math.log(Ry/Ri)/(2*Math.PI*L*kvegg);
	
	return  veskeDampGrensesnitt+veke+vegg;
	}


public double Pv_delta(double psatForTdeltaLiquid,double TdeltaLiquid,double sigma,double reff,double rho_l,double Rg)
	{
	double Pv_delta = psatForTdeltaLiquid+10;
	double x = (Pv_delta-psatForTdeltaLiquid-2*sigma / reff) / (rho_l*Rg*TdeltaLiquid);
	
	int endlessloopstopper = 0;
	
	while(Math.abs(Pv_delta - psatForTdeltaLiquid*Math.exp(x)) > 0.000001)
		{
		Pv_delta -= Pv_delta - psatForTdeltaLiquid*Math.exp(x);
		x = (Pv_delta-psatForTdeltaLiquid-2*sigma / reff) / (rho_l*Rg*TdeltaLiquid);
		if (endlessloopstopper > 1000)  {System.out.println("Pv_delta kunne ikke bli funnet");break;}
		endlessloopstopper++;
		}
	return Pv_delta;
	}

public int getWetpoint(double[] Pv, double[] Pl, double Lk,double La,double Le) //(*@\label{wetpointPos}@*)
	{
	int kondensatorinngang = (int) (Pv.length - (Pv.length / (Lk + La + Le))*Lk);
	double dampTrykkdifferanse = Pv[Pv.length-1] - Pv[kondensatorinngang];
	double vskeTrykkdifferanse = Pl[Pl.length-1] - Pl[kondensatorinngang];
	
	if (dampTrykkdifferanse > vskeTrykkdifferanse) return kondensatorinngang;
	else return Pl.length-1;
	
	}
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= KOMPRESIBEL ENDIMENSJONAL ANALYSE -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

public double A(double Re_r)
	{
	double c = Math.pow(Math.pow(5+ 18/Re_r,2)-8.8, 0.5);
	return (15/22)*(5+18/Re_r-c);
	}

public double F3(double A)
	{
	return 8*(0.25-(A/10)+(Math.pow(A,2)/30) - 2*(Math.pow(A,3)/945));    
	}
public double HAF(double A)
	{
	return -0.4 * (1 -  2*A/3 +  4*(Math.pow(A,2)/63)    );
	}
public double HVE(double A,double hm,double Hr,double vm)
	{
	return hm - Hr + 1.5*(F3(A)*Math.pow(vm,2));
	}
public double GRP(double Rg, double P)
	{
	return 1- Math.log(Rg)/Math.log(P);  //(egentlig partiellderviert)
	}
public double GRT(double Tm, double P)
	{
	return 1+ Math.log(Tm)/Math.log(P);  //(egentlig partiellderviert)
	}
public double GB(double A)
	{
	return (1- A/6 + (2/45)*Math.pow(A, 2));
	}
public double HB(double A)
	{
	return -((1/6)-(4*A/45) );
	}



public double dqR_dz(double R_v,double dm_dz,double rho_R,double hfg)
	{
	return (1/(2*Math.PI*R_v))*dm_dz*(hfg+Math.pow((1/(2*Math.PI*R_v*rho_R))*dm_dz,2));
	}



public double lewis1(double rho_m,double v_m,double p,double A,double Rg,double Tm,double u,double R_v,double dlnp_dz,double dlnAv_dz)
	{
	double a_dlnp_dz = 1- (4*rho_m*Math.pow(v_m,2))/(3*p) * GB(A)*GRP(Rg,p);
	double b_dlnTm_dz = (4*rho_m*Math.pow(v_m,2))/(3*p) * GB(A)*GRT(Tm,p);
	double c_dA_dz = (4*rho_m*Math.pow(v_m,2))/(3*p)*HB(A);
	
	double d = -((8*u*v_m)/(Math.pow(R_v, 2)*p))*(1+(2/3)*A)-((8*rho_m*Math.pow(v_m,2))/(3*p))*GB(A)*(dlnp_dz-dlnAv_dz);
	
	return a_dlnp_dz+b_dlnTm_dz+c_dA_dz-d; //skal bli null
	}

public double lewis2(double  dhm_dlnp_Tm,double A,double v_m,double  Rg, double P)
	{
	double a_dlnp_dz = dhm_dlnp_Tm - F3(A)*Math.pow(v_m, 2)*GRP(Rg, P);
	return 0.0;
	}
}//eND OF class


