


	/*
	 * Copyright (c) 1995 - 2008 Sun Microsystems, Inc.  All rights reserved.
	 *
	 * Redistribution and use in source and binary forms, with or without
	 * modification, are permitted provided that the following conditions
	 * are met:
	 *
	 *   - Redistributions of source code must retain the above copyright
	 *     notice, this list of conditions and the following disclaimer.
	 *
	 *   - Redistributions in binary form must reproduce the above copyright
	 *     notice, this list of conditions and the following disclaimer in the
	 *     documentation and/or other materials provided with the distribution.
	 *
	 *   - Neither the name of Sun Microsystems nor the names of its
	 *     contributors may be used to endorse or promote products derived
	 *     from this software without specific prior written permission.
	 *
	 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
	 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
	 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
	 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
	 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
	 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
	 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
	 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
	 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
	 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
	 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
	 */ 


	import javax.swing.JInternalFrame;

	import java.awt.event.*;
	import java.awt.*;

	import org.jfree.*;
	import org.jfree.data.xy.DefaultXYDataset;
import org.jfree.data.xy.XYDataset;
	import org.jfree.data.xy.XYSeries;
	import org.jfree.data.xy.XYSeriesCollection;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.labels.StandardXYToolTipGenerator;
	import org.jfree.chart.plot.Plot;
import org.jfree.chart.plot.XYPlot;
	import org.jfree.chart.ChartFactory;
	import org.jfree.chart.ChartPanel;
	import org.jfree.chart.JFreeChart;
	import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.renderer.xy.XYItemRenderer;
import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;
import org.jfree.chart.urls.StandardXYURLGenerator;
import org.jfree.data.DefaultKeyedValues;
import org.jfree.data.Range;




	/* Used by InternalFrameDemo.java. */
	public class limitChartFrame  extends JInternalFrame {
	    static int openFrameCount = 0;
	    static final int xOffset = 30, yOffset = 30;

	    public limitChartFrame(double[] tallserie,double[] serieBolingLimit,double[] serieSonicLimit,double[] vicousLimitKurve, double tmin) {
	        super("Begrensningskurve for Heatpipe", 
	              true, //resizable
	              true, //closable
	              true, //maximizable
	              true);//iconifiable
	        	

	        //Lager serie med punkter for Pv(z):
	        XYSeries seriesCaplimit = new XYSeries("Kapillrbegrensning");
	        
	        for(int i =0;i< tallserie.length;i++)
	        	{
	        	if (tallserie[i] > 0) seriesCaplimit.add(i+tmin, tallserie[i]);
	        	}
	        
	        
	        
	        XYSeries kokebegrensningSerie = new XYSeries("Kokebegrensning");
	        
	        for(int i =0;i< serieBolingLimit.length;i++)
	        	{
	        	kokebegrensningSerie.add(i+tmin, serieBolingLimit[i]);
	        	}
	        //Lager linjer for  markere de ulike delene i fordamper:
	        XYSeries soniskbegrensningSerie = new XYSeries("Sonisk begrensning");
	        
	        for(int i =0;i< serieSonicLimit.length;i++)
	        	{
	        	soniskbegrensningSerie.add(i+tmin, serieSonicLimit[i]);
	        	}
	        
	        XYSeries vicousbegrensningSerie = new XYSeries("Visks begrensning");
	        
	        for(int i =0;i< vicousLimitKurve.length;i++)
	        	{
	        	if (vicousLimitKurve[i] > 0) vicousbegrensningSerie.add(i+tmin, vicousLimitKurve[i]);
	        	}
	        
	       
	        
	        //         Add the series to your data set
	        XYSeriesCollection dataset = new XYSeriesCollection();
	        dataset.addSeries(seriesCaplimit);
	        dataset.addSeries(kokebegrensningSerie);
	        dataset.addSeries(soniskbegrensningSerie);
	        dataset.addSeries(vicousbegrensningSerie);
	       
	        //         Generate the graph
	        JFreeChart chart = createXYLineChart("Varmetransportbegrensninger", // Title
	                "Fordampningstemperatur [K]", // x-axis Label
	                "Varmebelastning i fordamper Qe [kW]", // y-axis Label
	                dataset, // Dataset
	                PlotOrientation.VERTICAL, // Plot Orientation
	                true, // Show Legend
	                true, // Use tooltips
	                false // Configure chart to generate URLs?
	            );
	        
	        	
	         
	        
	        ChartPanel chartpanel = new ChartPanel(chart);
	        
	        setSize(300,300);
	        getContentPane().add(chartpanel, BorderLayout.CENTER);

	        //Set the window's location.
	        setLocation(xOffset*openFrameCount, yOffset*openFrameCount);
	        
	      
	        
	        setVisible(true);
	        
	    }
public JFreeChart createXYLineChart(String title,
											String xAxisLabel,
											String yAxisLabel,
										    XYDataset dataset,
									    	PlotOrientation orientation,
                                            boolean legend,
                                            boolean tooltips,
                                            boolean urls) {
	    		    
	    		            if (orientation == null) {
	    		                throw new IllegalArgumentException("Null 'orientation' argument.");
	    		            }
	    		            NumberAxis xAxis = new NumberAxis(xAxisLabel);
	    		            xAxis.setAutoRangeIncludesZero(false);
	    		            NumberAxis yAxis = new NumberAxis(yAxisLabel);
	    		            yAxis.setAutoRangeIncludesZero(false);
	    		            XYItemRenderer renderer = new XYLineAndShapeRenderer(true, false);
	    		            XYPlot plot = new XYPlot(dataset, xAxis, yAxis, renderer);
	    		            plot.setOrientation(orientation);
	    		            if (tooltips) {
	    		                renderer.setBaseToolTipGenerator(new StandardXYToolTipGenerator());
	    		            }
	    		            if (urls) {
	    		                renderer.setURLGenerator(new StandardXYURLGenerator());
	    		            }
	    		    
	    		            JFreeChart chart = new JFreeChart(title, JFreeChart.DEFAULT_TITLE_FONT,
	    		                    plot, legend);
	    		            //currentTheme.apply(chart);
	    		            return chart;
	    }
	
	}


